///////////////////////////////////////////////////////////////////////////////
// ViewForm.h
// ==========
// View component of dialog window
//
//  AUTHORL Song Ho Ahn (song.ahn@gmail.com)
// CREATED: 2023-04-12
// UPDATED: 2023-04-20
///////////////////////////////////////////////////////////////////////////////

#ifndef VIEW_FORM_H
#define VIEW_FORM_H

#include <windows.h>
#include "Controls.h"

namespace Win
{
    class ViewForm
    {
    public:
        ViewForm();
        ~ViewForm();

        void initControls(HWND handle);         // init all controls

        // update controls on the form
        void updateKeyDown(int key);
        void updateKeyUp(int key);
        void updateMousePosition(int x, int y);
        void updateMouseDown(int button);
        void updateMouseUp(int button);
        void updateMouseWheel(int delta);

    protected:

    private:
        // controls
        Win::TextBox textKeyDown;
        Win::TextBox textKeyUp;
        Win::TextBox textMousePos;
        Win::TextBox textWheel;
        Win::RadioButton radioLeft;
        Win::RadioButton radioMiddle;
        Win::RadioButton radioRight;
    };
}

#endif
